.586
.model flat,stdcall
option casemap:none
.xmm

include \masm32\include\windows.inc
include \masm32\macros\macros.asm

include \masm32\include\masm32.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\shell32.inc

includelib \masm32\lib\masm32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\shell32.lib

Main proto
WndProc proto :DWORD,:DWORD,:DWORD,:DWORD
RenderMandelbrot proto
RenderJulia proto

.const

PLOT_SIZE equ 500
MAX_ITERATIONS equ 200

.data

szClassName db "Mandelbrot_WndClass",0
szWindowTitle db "Mandelbrot by Preeyan Parmar",0
buf db 512 dup(0)

Min REAL8 -2.0
PixelWidth REAL8 0.008
Four REAL8 4.0
Two REAL8 2.0
PlotSize REAL8 500.0

align 16
M_MinRe REAL8 -2.0
M_MinIm REAL8 -2.0
J_MinRe REAL8 -2.0
J_MinIm REAL8 -2.0
M_PixelWidth REAL8 0.008
J_PixelWidth REAL8 0.008

C_Re REAL8 0.0
C_Im REAL8 0.0
Z_Re REAL8 0.0
Z_Im REAL8 0.0
K_Re REAL8 0.0
K_Im REAL8 0.0

.data?

hInstance HINSTANCE ?
pDIBMandelbrot DWORD ?
pDIBJulia DWORD ?
pBIHMandelbrot DWORD ?
pBIHJulia DWORD ?


.code

start:
	
	invoke Main
	invoke ExitProcess,eax
	
Main proc
	
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	
	invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,PLOT_SIZE * PLOT_SIZE * 4 + sizeof(BITMAPINFOHEADER)
	mov pBIHMandelbrot,eax
	mov dword ptr [eax],sizeof(BITMAPINFOHEADER)
	mov dword ptr [eax+4],PLOT_SIZE
	mov dword ptr [eax+8],PLOT_SIZE
	mov word ptr [eax+12],1
	mov word ptr [eax+14],32
	mov dword ptr [eax+16],BI_RGB
	add eax,sizeof(BITMAPINFOHEADER)
	mov pDIBMandelbrot,eax
	invoke GlobalAlloc,GMEM_FIXED or GMEM_ZEROINIT,PLOT_SIZE * PLOT_SIZE * 4 + sizeof(BITMAPINFOHEADER)
	mov pBIHJulia,eax
	mov dword ptr [eax],sizeof(BITMAPINFOHEADER)
	mov dword ptr [eax+4],PLOT_SIZE
	mov dword ptr [eax+8],PLOT_SIZE
	mov word ptr [eax+12],1
	mov word ptr [eax+14],32
	mov dword ptr [eax+16],BI_RGB
	add eax,sizeof(BITMAPINFOHEADER)
	mov pDIBJulia,eax
	
	mov wc.cbSize,sizeof wc
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc,offset WndProc
	mov wc.cbClsExtra,NULL
	mov wc.cbWndExtra,NULL
	mov hInstance,FUNC(GetModuleHandle,NULL)
	mov wc.hInstance,eax
	mov wc.hIcon,FUNC(LoadIcon,eax,10)
	mov wc.hIconSm,eax
	mov wc.hCursor,FUNC(LoadCursor,NULL,IDC_ARROW)
	mov wc.hbrBackground,COLOR_WINDOW+1
	mov wc.lpszMenuName,20
	mov wc.lpszClassName,offset szClassName
	invoke RegisterClassEx,addr wc
	
	invoke CreateWindowEx,NULL,addr szClassName,addr szWindowTitle,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL
	push eax
	push SW_SHOWMAXIMIZED
	push eax
	call ShowWindow
	call UpdateWindow
	
MLBegin:
	invoke GetMessage,addr msg,NULL,0,0
	test eax,eax
	jz MLEnd
	invoke TranslateMessage,addr msg
	invoke DispatchMessage,addr msg
	jmp MLBegin
MLEnd:
	
	invoke GlobalFree,pBIHJulia
	invoke GlobalFree,pBIHMandelbrot
	
	ret

Main endp

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	LOCAL ps:PAINTSTRUCT
	LOCAL hDC:HDC
	LOCAL rect:RECT
	LOCAL temp:REAL8
	LOCAL x:WORD
	
	mov eax,uMsg
	.if eax==WM_CREATE
		invoke RenderMandelbrot
		invoke RenderJulia
	.elseif eax==WM_DESTROY
		invoke PostQuitMessage,0
	.elseif eax==WM_RBUTTONDOWN
		mov eax,lParam
		cmp ax,PLOT_SIZE
		jl @F
		xor eax,eax
		ret
		@@:
		shr eax,16
		cmp ax,PLOT_SIZE
		jl @F
		xor eax,eax
		ret
		@@:
		mov x,PLOT_SIZE
		sub x,ax
		fild x
		fmul M_PixelWidth
		fadd M_MinIm
		fstp K_Im
		mov eax,lParam
		mov x,ax
		fild x
		fmul M_PixelWidth
		fadd M_MinRe
		fstp K_Re
		movlpd xmm0,Min
		movlpd xmm1,PixelWidth
		movlpd J_MinRe,xmm0
		movlpd J_PixelWidth,xmm1
		movlpd J_MinIm,xmm0
		invoke RenderJulia
		invoke GetClientRect,hWnd,addr rect
		invoke InvalidateRect,hWnd,addr rect,FALSE
	.elseif eax==WM_LBUTTONDOWN
		mov eax,lParam
		shr eax,16
		cmp ax,PLOT_SIZE
		jl @F
		xor eax,eax
		ret
		@@:
		mov eax,lParam
		cmp ax,PLOT_SIZE
		jl ZoomMandelbrot
		jg @F
		xor eax,eax
		ret
		@@:
		cmp ax,PLOT_SIZE*2
		jle ZoomJulia
		xor eax,eax
		ret
		ZoomMandelbrot:
		mov eax,wParam
		and eax,MK_CONTROL or MK_SHIFT
		.if eax==MK_CONTROL or MK_SHIFT
			movlpd xmm0,Min
			movlpd xmm1,PixelWidth
			movlpd M_MinRe,xmm0
			movlpd M_PixelWidth,xmm1
			movlpd M_MinIm,xmm0
		.else
			mov eax,lParam
			sub ax,PLOT_SIZE/2
			mov x,ax
			fild x
			fmul M_PixelWidth
			fadd M_MinRe
			fstp M_MinRe
			mov eax,lParam
			shr eax,16
			mov x,PLOT_SIZE/2
			sub x,ax
			fild x
			fmul M_PixelWidth
			fadd M_MinIm
			fstp M_MinIm
			mov eax,wParam
			and eax,MK_CONTROL or MK_SHIFT
			.if eax==MK_CONTROL
				movlpd xmm3,PlotSize
				movlpd xmm2,M_PixelWidth
				movlpd xmm1,Four
				movhpd xmm3,PlotSize
				movhpd xmm2,M_PixelWidth
				movhpd xmm1,Four
				movapd xmm0,M_MinRe
				mulpd xmm2,xmm3
				divpd xmm2,xmm1
				addpd xmm0,xmm2
				movapd M_MinRe,xmm0
				movlpd xmm0,M_PixelWidth
				movlpd xmm1,Two
				divsd xmm0,xmm1
				movlpd M_PixelWidth,xmm0
			.elseif eax==MK_SHIFT
				movlpd xmm0,M_PixelWidth
				movlpd xmm1,Two
				mulsd xmm0,xmm1
				movlpd M_PixelWidth,xmm0
				movlpd xmm3,PlotSize
				movlpd xmm2,M_PixelWidth
				movlpd xmm1,Four
				movhpd xmm3,PlotSize
				movhpd xmm2,M_PixelWidth
				movhpd xmm1,Four
				movapd xmm0,M_MinRe
				mulpd xmm2,xmm3
				divpd xmm2,xmm1
				subpd xmm0,xmm2
				movapd M_MinRe,xmm0
			.endif
		.endif
		invoke RenderMandelbrot
		invoke GetClientRect,hWnd,addr rect
		invoke InvalidateRect,hWnd,addr rect,FALSE
		xor eax,eax
		ret
		ZoomJulia:
		mov eax,wParam
		and eax,MK_CONTROL or MK_SHIFT
		.if eax==MK_CONTROL or MK_SHIFT
			movlpd xmm0,Min
			movlpd xmm1,PixelWidth
			movlpd J_MinRe,xmm0
			movlpd J_PixelWidth,xmm1
			movlpd J_MinIm,xmm0
		.else
			mov eax,lParam
			sub ax,PLOT_SIZE*3/2
			mov x,ax
			fild x
			fmul J_PixelWidth
			fadd J_MinRe
			fstp J_MinRe
			mov eax,lParam
			shr eax,16
			mov x,PLOT_SIZE/2
			sub x,ax
			fild x
			fmul J_PixelWidth
			fadd J_MinIm
			fstp J_MinIm
			mov eax,wParam
			and eax,MK_CONTROL or MK_SHIFT
			.if eax==MK_CONTROL
				movlpd xmm3,PlotSize
				movlpd xmm2,J_PixelWidth
				movlpd xmm1,Four
				movhpd xmm3,PlotSize
				movhpd xmm2,J_PixelWidth
				movhpd xmm1,Four
				movapd xmm0,J_MinRe
				mulpd xmm2,xmm3
				divpd xmm2,xmm1
				addpd xmm0,xmm2
				movapd J_MinRe,xmm0
				movlpd xmm0,J_PixelWidth
				movlpd xmm1,Two
				divsd xmm0,xmm1
				movlpd J_PixelWidth,xmm0
			.elseif eax==MK_SHIFT
				movlpd xmm0,J_PixelWidth
				movlpd xmm1,Two
				mulsd xmm0,xmm1
				movlpd J_PixelWidth,xmm0
				movlpd xmm3,PlotSize
				movlpd xmm2,J_PixelWidth
				movlpd xmm1,Four
				movhpd xmm3,PlotSize
				movhpd xmm2,J_PixelWidth
				movhpd xmm1,Four
				movapd xmm0,J_MinRe
				mulpd xmm2,xmm3
				divpd xmm2,xmm1
				subpd xmm0,xmm2
				movapd J_MinRe,xmm0
			.endif
		.endif
		invoke RenderJulia
		invoke GetClientRect,hWnd,addr rect
		invoke InvalidateRect,hWnd,addr rect,FALSE
		xor eax,eax
		ret
	.elseif eax==WM_COMMAND
		mov eax,wParam
		.if eax==100
			invoke ShellAbout,hWnd,SADD("Mandelbrot by Preeyan Parmar#will not rule the world!!"),SADD("This program is freeware.",13,10,"If you would like the source code, email me."),FUNC(LoadIcon,hInstance,10)
		.endif
	.elseif eax==WM_PAINT
		invoke BeginPaint,hWnd,addr ps
		push eax
		invoke SetDIBitsToDevice,eax,0,0,PLOT_SIZE,PLOT_SIZE,0,0,0,PLOT_SIZE,pDIBMandelbrot,pBIHMandelbrot,DIB_RGB_COLORS
		pop eax
		invoke SetDIBitsToDevice,eax,PLOT_SIZE+1,0,PLOT_SIZE,PLOT_SIZE,0,0,0,PLOT_SIZE,pDIBJulia,pBIHJulia,DIB_RGB_COLORS
		invoke EndPaint,hWnd,addr ps
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret

WndProc endp

RenderMandelbrot proc

	LOCAL temp:DWORD
	LOCAL real:REAL8
	
	push ebx
	push esi
	push edi
	
	mov ebx,pDIBMandelbrot
	
	xor esi,esi
	ColStart:
	
		;C_Re = M_MinRe + (esi * M_PixelWidth)
		mov temp,esi
		fild temp
		fld M_PixelWidth
		fmul
		fadd M_MinRe
		fstp C_Re
		
		xor edi,edi
		RowStart:
			
			;C_Im = M_MinIm + (edi * M_PixelWidth)
			mov temp,edi
			fild temp
			fld M_PixelWidth
			fmul
			fadd M_MinIm
			fstp C_Im
			
			;Z = C
			movapd xmm0,C_Re
			movapd Z_Re,xmm0
			
			mov ecx,MAX_ITERATIONS
			NextIteration:
				;Z_Re^2 + Z_Im^2 > 4
				movapd xmm0,Z_Re
				movlpd xmm3,Four
				mulpd xmm0,xmm0
				movhpd real,xmm0
				movapd xmm2,xmm0
				movlpd xmm1,real
				addpd xmm2,xmm1
				cmppd xmm2,xmm3,6
				movlpd real,xmm2
				lea edx,real
				mov eax,[edx]
				test eax,eax
				jnz BreakLoop
				
				;Z_Re = Z_Re^2 - Z_Im^2
				;Z_Im = 2 * Z_Re * Z_Im
				movlpd xmm2,Z_Re
				movlpd xmm3,Two
				subpd xmm0,xmm1
				movlpd xmm1,Z_Im
				mulsd xmm2,xmm3
				movlpd Z_Re,xmm0
				mulsd xmm1,xmm2
				movlpd Z_Im,xmm1
				;Z = Z + C
				movapd xmm0,Z_Re
				movapd xmm1,C_Re
				addpd xmm0,xmm1
				movapd Z_Re,xmm0
			sub ecx,1
			jnz NextIteration
			BreakLoop:
			cmp ecx,MAX_ITERATIONS/2
			jg RedToBlack
			test ecx,ecx
			jnz WhiteToRed
			jmp PlotPixel
			WhiteToRed:
			mov edx,ecx
			mov ecx,MAX_ITERATIONS/2
			sub ecx,edx
			invoke IntMul,ecx,255
			nop
			invoke IntDiv,eax,MAX_ITERATIONS/2-1
			mov ecx,0FF0000h
			mov ch,al
			mov cl,al
			jmp PlotPixel
			RedToBlack:
			sub ecx,MAX_ITERATIONS/2
			mov edx,ecx
			mov ecx,MAX_ITERATIONS/2
			sub ecx,edx
			invoke IntMul,ecx,255
			invoke IntDiv,eax,MAX_ITERATIONS/2
			movzx ecx,al
			shl ecx,16
				
			PlotPixel:
			mov eax,PLOT_SIZE
			xor edx,edx
			mul edi
			add eax,esi
			shl eax,2
			add eax,ebx
			mov dword ptr [eax],ecx
			EndLoop:
			
		add edi,1
		cmp edi,PLOT_SIZE
		jne RowStart
	add esi,1
	cmp esi,PLOT_SIZE
	jne ColStart
	
	pop edi
	pop esi	
	pop ebx
	ret

RenderMandelbrot endp

RenderJulia proc

	LOCAL temp:DWORD
	LOCAL real:REAL8
	
	push ebx
	push esi
	push edi
	
	mov ebx,pDIBJulia
	
	xor esi,esi
	ColStart:
	
		;C_Re = M_MinRe + (esi * M_PixelWidth)
		mov temp,esi
		fild temp
		fld J_PixelWidth
		fmul
		fadd J_MinRe
		fstp C_Re
		
		xor edi,edi
		RowStart:
			
			;C_Im = M_MinIm + (edi * M_PixelWidth)
			mov temp,edi
			fild temp
			fld J_PixelWidth
			fmul
			fadd J_MinIm
			fstp C_Im
			
			;Z = C
			movapd xmm0,C_Re
			movapd Z_Re,xmm0
			
			mov ecx,MAX_ITERATIONS
			NextIteration:
				;Z_Re^2 + Z_Im^2 > 4
				movapd xmm0,Z_Re
				movlpd xmm3,Four
				mulpd xmm0,xmm0
				movhpd real,xmm0
				movapd xmm2,xmm0
				movlpd xmm1,real
				addpd xmm2,xmm1
				cmppd xmm2,xmm3,6
				movlpd real,xmm2
				lea edx,real
				mov eax,[edx]
				test eax,eax
				jnz BreakLoop
				
				;Z_Re = Z_Re^2 - Z_Im^2
				;Z_Im = 2 * Z_Re * Z_Im
				movlpd xmm2,Z_Re
				movlpd xmm3,Two
				subpd xmm0,xmm1
				movlpd xmm1,Z_Im
				mulsd xmm2,xmm3
				movlpd Z_Re,xmm0
				mulsd xmm1,xmm2
				movlpd Z_Im,xmm1
				;Z = Z + C
				movapd xmm0,Z_Re
				movapd xmm1,K_Re
				addpd xmm0,xmm1
				movapd Z_Re,xmm0
			sub ecx,1
			jnz NextIteration
			BreakLoop:
			cmp ecx,MAX_ITERATIONS/2
			jg BlueToBlack
			test ecx,ecx
			jnz WhiteToBlue
			jmp PlotPixel
			WhiteToBlue:
			mov edx,ecx
			mov ecx,MAX_ITERATIONS/2
			sub ecx,edx
			invoke IntMul,ecx,255
			invoke IntDiv,eax,MAX_ITERATIONS/2-1
			movzx ecx,al
			mov ch,al
			shl ecx,8
			mov cl,0FFh
			jmp PlotPixel
			BlueToBlack:
			sub ecx,MAX_ITERATIONS/2
			mov edx,ecx
			mov ecx,MAX_ITERATIONS/2
			sub ecx,edx
			invoke IntMul,ecx,255
			invoke IntDiv,eax,MAX_ITERATIONS/2
			movzx ecx,al
				
			PlotPixel:
			mov eax,PLOT_SIZE
			xor edx,edx
			mul edi
			add eax,esi
			shl eax,2
			add eax,ebx
			mov dword ptr [eax],ecx
			
		add edi,1
		cmp edi,PLOT_SIZE
		jne RowStart
	add esi,1
	cmp esi,PLOT_SIZE
	jne ColStart
	
	pop edi
	pop esi	
	pop ebx
	ret

RenderJulia endp

end start